library better_print;

import 'package:flutter/widgets.dart';

/// A better way to show print message
///
/// [maxLine] to control number of line to show.
betterPrint(dynamic message, [int maxLine = 0]) {
  if (message.runtimeType != String) message = message.toString();
  final stackTrace = StackTrace.current;
  Iterable<String> lines = stackTrace.toString().trimRight().split('\n');
  // removing [betterPrint] from stack
  String line = lines.toList()[1];
  final i = line.indexOf('package:');
  line = lines.toList()[2];
  // getting file info and restructure if web
  final file = i >= 0
      ? line.substring(i)
      : '${line.replaceFirst('packages/', 'package:')}';
  if (maxLine > 0) {
    lines = lines.take(maxLine + (i < 0 ? 2 : 1));
    debugPrint(
        '$message \n${FlutterError.defaultStackFilter(lines.toList()..removeRange(0, i < 0 ? 2 : 1)).join('\n').replaceAll('packages/', 'package:')}');
  } else {
    debugPrint('$message \n $file');
  }
}
